#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <errno.h>

#include "outils.h"

int
outil_cat_copy (int src, int dst)
{
    char buf[1024];
    int count;
    for (;;) {
        if ((count = read(src, buf, 1024)) < 0) {
            perror("cat: read");
            return -1;
        }
        if (count == 0) break;
        if (write(dst, buf, count) < 0) {
            perror("cat: write");
            return -1;
        }
    }
    return 0;
}

int
outil_cat_file (const char *pathname)
{
    int fd, retv;
    if ((fd = open(pathname, O_RDONLY)) < 0) {
        fprintf(stderr, "cat: open: '%s': %s\n", pathname, strerror(errno));
        return -1;
    }
    retv = outil_cat_copy(fd, STDOUT_FILENO);
    close(fd);
    return retv;
}

int
outil_cat (int argc, char **argv)
{
    if (argc < 2) {
        if (outil_cat_copy(STDIN_FILENO, STDOUT_FILENO) < 0) {
            return 1;
        }
        return 0;
    }
    for (int i = 1; i < argc; i++) {
        if (outil_cat_file(argv[i]) < 0) {
            return 1;
        }
    }
    return 0;
}

#ifdef STANDALONE
OUTILMAIN(cat)
#endif
